#pragma once
// wi' =  wi - e * a * xi
// e = z - p

// x0  Y0  Z0
//
// x1  Y1  Z1
//
// x2  Y2  Z2
//
// x3  Y3  Z3
//

// Mi = f(SUM(i, Wi * Ni))

class Neuron
{
  public:
    Neuron();
    ~Neuron();

    bool Init(int WeightCount);

    double CurrentState;
    double *Weight;
    int WeigthCount;
};

class NeuralNet
{
  public:
    NeuralNet(int LayerCount, ...); // 0th layer == input, last layer == output
    ~NeuralNet();

    int LayerCount;
    int *NeuronCountInLayer;

    Neuron **Neurons;

    void Go(double *DataIn, double *DataOut);
    void ErrorCorrection(double CorrectionRatio, double *CorrectDataOut);
    void Dump();
};

